%define major     15
%define libqs5    %mklibname qscintilla2_qt5_ %{major}
%define libqs5dev %mklibname qscintilla2-qt5 -d

Name:           qscintilla
Version:        2.14.1
Release:        %mkrel 1
Summary:        Port to Qt of Neil Hodgson's Scintilla C++ editor class
License:        GPLv2+
Group:          System/Libraries
URL:            http://www.riverbankcomputing.co.uk/software/qscintilla/intro
Source0:        https://www.riverbankcomputing.com/static/Downloads/QScintilla/%{version}/QScintilla_src-%{version}.tar.xz
BuildRequires:  pkgconfig(dbus-1)
BuildRequires:  sed

# Qt5
BuildRequires:  pkgconfig(Qt5Designer)
BuildRequires:  pkgconfig(Qt5Gui)
BuildRequires:  pkgconfig(Qt5PrintSupport)
BuildRequires:  pkgconfig(Qt5Widgets)
BuildRequires:  pkgconfig(Qt5Xml)
BuildRequires:  python3-qt5-devel

# Python 3
BuildRequires:  pkgconfig(python3)
BuildRequires:  python3-dbus
BuildRequires:  python3-sip-devel >= 4.19
BuildRequires:  python3-pyqt-builder

%description
As well as features found in standard text editing components,
QScintilla includes features especially useful when editing and
debugging source code. These include support for syntax styling, error
indicators, code completion and call tips. The selection margin can
contain markers like those used in debuggers to indicate breakpoints
and the current line. Styling choices are more open than with many
editors, allowing the use of proportional fonts, bold and italics,
multiple foreground and background colours and multiple fonts.

#--------------------------------------------------------------

%package -n     %{libqs5}
Summary:        Port to Qt5 of Neil Hodgson's Scintilla C++ editor class
Group:          System/Libraries
Requires:       qscintilla2-qt5-common >= %{version}-%{release}
Conflicts:	qscintilla2-qt5-common < 2.13.3

Obsoletes:      lib64qscintilla2_13
Obsoletes:      lib64qscintilla2-qt5_13

%description -n %{libqs5}
As well as features found in standard text editing components,
QScintilla includes features especially useful when editing and
debugging source code. These include support for syntax styling, error
indicators, code completion and call tips. The selection margin can
contain markers like those used in debuggers to indicate breakpoints
and the current line. Styling choices are more open than with many
editors, allowing the use of proportional fonts, bold and italics,
multiple foreground and background colours and multiple fonts.

%files -n %{libqs5}
%{_qt5_libdir}/libqscintilla2_qt5.so.%{major}*
%{_qt5_plugindir}/designer/libqscintillaplugin.so
#--------------------------------------------------------------

%package -n     %{libqs5dev}
Summary:        Libraries, include and other files to develop applications with QScintilla for Qt5
Group:          Development/Libraries
Requires:       %{libqs5} = %{version}-%{release}
Provides:       %{name}-qt5-devel = %{version}-%{release}

Obsoletes:      lib64qscintilla2-devel
Provides:       lib64qscintilla2-devel = %{version}-%{release}

%description -n %{libqs5dev}
This packages contains the libraries, include and other files
you can use to develop applications with QScintilla.

%files -n %{libqs5dev}
%{_qt5_includedir}/*
%{_qt5_libdir}/libqscintilla2_qt5.so
%{_qt5_archdatadir}/mkspecs/features/qscintilla2.prf

#--------------------------------------------------------------

%package -n     qscintilla2-qt5-common
Summary:        Common files for %{name}-qt5
Group:          System/Libraries

%description -n qscintilla2-qt5-common
This packages contains translations and designer plugin for %{name}-qt5.

%files -n qscintilla2-qt5-common
%{_qt5_translationdir}/qscintilla*.qm

#--------------------------------------------------------------

%package -n     python3-qt5-qscintilla
Summary:        Python3 Qt5 QScintilla bindings
Group:          Development/Libraries
Requires:       python3-qt5
Requires:       %{libqs5} = %{version}

Obsoletes:      python-qt4-qscintilla
Obsoletes:      python-qt5-qscintilla
Obsoletes:      python3-qt4-qscintilla

%description -n python3-qt5-qscintilla
Python3 Qt5 QScintilla bindings.

%files -n python3-qt5-qscintilla
%{python3_sitearch}/PyQt5/Qsci.abi3.so
%{python3_sitearch}/PyQt5/bindings/Qsci/
%{python3_sitearch}/QScintilla-%{version}.dist-info/

#--------------------------------------------------------------

%package        doc-qt5
Summary:        QScintilla docs
Group:          Development/KDE and Qt
Obsoletes:      qscintilla-doc
BuildArch:      noarch

%description    doc-qt5
QScintilla doc.

%files doc-qt5
%doc NEWS doc
%{_qt5_datadir}/qsci/api/python/*

#--------------------------------------------------------------

%prep
%setup -qn QScintilla_src-%{version}
%autopatch -p1

%build
### Qt5 build ###
export LDFLAGS="-L/usr/lib64/libglvnd/ $LDFLAGS"
export QMAKEFEATURES=$PWD/src/features;

pushd src
	%{qmake_qt5} qscintilla.pro
	%make_build
popd

pushd designer
	%{qmake_qt5} designer.pro INCLUDEPATH+=../src LIBS+=-L../src
	%make_build
popd

pushd Python
ln -s pyproject-qt5.toml pyproject.toml
LD_LIBRARY_PATH=$PWD/../src sip-build --no-make  --qmake=%{_qt5_bindir}/qmake --api-dir=%{_qt5_datadir}/qsci/api/python --verbose \
    --qsci-include-dir=../src --qsci-library-dir=../src/ --qsci-features-dir=../src/features
%make_build -C build
popd

%install
### Qt5 install ###
%make_install -C src INSTALL_ROOT=%{buildroot}
%make_install -C designer INSTALL_ROOT=%{buildroot}
%make_install -C Python/build INSTALL_ROOT=%{buildroot}
# Drop Python api files
rm -f %{buildroot}%{_qt5_datadir}/qsci/api/python/Python*.api

%changelog
* Fri Jan 12 2024 pp - 2.14.1-1pclos2024
- new version following MGA

* Wed Aug 03 2022 tex - 2.11.6-3pclos2022
- fix python-sip-api

* Sun Jul 31 2022 TerryN <terryn94 at gmail.com> 2.11.6-2pclos2022
- rebuild for python 3.10

* Sat Feb 27 2021 tex - 2.11.6-1pclos2021
- new version
